<?php
class extension_auth extends module {
	function __construct() {
		$this->name="extension_auth";
		$this->title="Расширеная авторизация";
		$this->module_category="<#LANG_SECTION_SYSTEM#>";
		$this->version = "020921v";
		$this->checkInstalled();
		
		global $db;
		$this->db = $db;
		
		ini_set('display_errors', 0);
		ini_set('display_startup_errors', 0);
		error_reporting(E_ALL);
		
		$this->loginURL = '/login.php';
		$this->blockURL = '/denied.php';
		$this->appStartType = php_sapi_name();
		$this->clientIP = $_SERVER['REMOTE_ADDR'];
		
		if($this->appStartType == 'cli' || $this->clientIP == '127.0.0.1' || $this->clientIP == 'localhost') {
			$this->clientIP = '127.0.0.1';
			$this->closeAuth = 1;
			$this->db->Disconnect();
		} else {
			$this->closeAuth = 0;
			$this->curPage = (empty($_SERVER["DOCUMENT_URI"])) ? $_SERVER['SCRIPT_NAME'] : $_SERVER["DOCUMENT_URI"];
			$this->curPageQuery = (isset($_SERVER['REQUEST_URI'])) ? $_SERVER['REQUEST_URI'] : '/';
			$this->referer = (isset($_SERVER["HTTP_REFERER"]) && !empty($_SERVER["HTTP_REFERER"])) ? $_SERVER["HTTP_REFERER"] : '';
		}
		
		
	}
	
	public function __destruct() {
		$this->db->Disconnect();
	}
	
	function banListCheck($type = 'ATTEMPT_OPEN') {
		if($this->config['SETTINGS_BANAFTER'] == '0') return false; 
		if($type == 'ATTEMPT_OPEN' && $this->config['SETTINGS_DDOSBAN'] != '1') return false;
		
		//Запишем попытку обновить страницу или войти с неверными данными
		$sel = SQLSelectOne("SELECT * FROM `ea_ban` WHERE `IP` = '".dbSafe($this->clientIP)."'");
		
		$sel['UPDATE'] = time();
		$sel[$type]++;
		if(!$sel['ADD']) $sel['ADD'] = time();
		if(!$sel['IP']) $sel['IP'] = $this->clientIP;
		
		if($sel['ATTEMPT_OPEN'] >= 3 || $sel['ATTEMPT_FAIL'] >= 3) {
			//Работаем только если бан настроен
			if($sel[$type] > $this->config['SETTINGS_BANAFTER']) {
				$sel['STATUS'] = 1;
				$sel['EXPIRE'] = ($this->config['SETTINGS_BANTIME'] != '-1') ? (time()+$this->config['SETTINGS_BANTIME']) : (time()+999999999);
				SQLInsertUpdate("ea_ban", $sel);
			}
		}
	}
	
	function banListClearIP() {
		//SQLExec("DELETE FROM `ea_ban` WHERE `IP` = '".dbSafe($this->clientIP)."' LIMIT 1");
		return true;
	}
	
	function debug() {
		echo '<pre>';
		var_dump($_SERVER);
		die;
	}
	
	function start() {
		if($this->closeAuth == 1) {
			return true;
		}
		
		if($this->curPage == '/nf.php') {
			$this->db->Disconnect();
		}

		//Запускаем сессию
		$session = new session("prj");
		$session->save();
		
		//Выкидываем если пустой IP, ибо нехер ходит с пустым!
		if(empty($this->clientIP) && $this->closeAuth != 1) {
			$this->unauthorized();
		}
		
		$this->getConfig();
		
		//Перехват Basic авторизации
		if(isset($_GET['basic'])) {
			if($_GET['basic'] == 1 && $this->config['SETTINGS_BASICREQ'] == 1) {
				if (!isset($_SERVER['PHP_AUTH_USER'])) {
					header('WWW-Authenticate: Basic realm="My Realm"');
					header('HTTP/1.0 401 Unauthorized');
					echo '<h1>Access Denied!</h1>';
					$this->db->Disconnect(); 
					exit;
				} else {
					$responce = $this->checkLoginPass($_SERVER['PHP_AUTH_USER'], $_SERVER['PHP_AUTH_PW']);
					
					if($responce == true) {
						return true;
					} else {
						$this->banListCheck('ATTEMPT_FAIL');
					}
				}
			}
		}

		if($this->loginURL == $this->curPage) {
			return true;
		}
		
		//Перехватим ГЕТ, если хотят выйти
		if(isset($_GET['logout']) && $this->closeAuth != 1) {
			if($_GET['logout'] == 'true') {
				$this->goToLogin();
			}
		}
		
		//Перехватим ГЕТ, если хотят ВОЙТИ ПО ТОКЕНУ
		if(isset($_GET['token'])) {
			if(!empty($_GET['token'])) {
				$checkToken = $this->checkToken($_GET['token']);
				
				if($checkToken["status"] == true) {
					//Авторизация успешна, пускаем 
					return true;
				}
			}
		}
		
		//Проверяем можно ли по IP или до файла, а потом уже сессию ибо куки могут быть отключены  || $_SESSION['EA_TYPE'] == 'IP' || $_SESSION['EA_TYPE'] == 'PATH'
		if(!isset($_SESSION['EA_TYPE'])) {
			$checkIP = $this->checkIP();
			if($checkIP == 1) {
				//Разрешено войти по ИП, вернем true и остановим скрипт
				return true;
			} else {
				$checkPath = $this->checkAccessByPath();
				if($checkPath == 1) {
					//Разрешено войти по ИП, вернем true и остановим скрипт
					return true;
				}
			}
		}
		//Если прошли дальше то по ИП и до файла нам запрещено, теперь уже без куки не войти!
	
		//Смотрим в сессию все ли нормально
		//Проблема с сессией
		if($this->sessionCheck() == 0) {
			$this->goToLogin($this->curPageQuery);
		}
		
		//Если все хорошо, то можно проверить на права при входе по токену или паролю
		if($_SESSION['EA_TYPE'] == 'TOKEN' || $_SESSION['EA_TYPE'] == 'LOGIN') {
			if ($this->checkAccessPermission() == 0) {
				//Если вернули 0 - то доступ запрещен!
				if($this->blockURL != $this->curPage) $this->blockPage($this->referer);
			}
		}
		
		//На всякий, сам не знаю зачем :D
		return true;
	}
	
	function sessionCheck() {
		$allow = 1;
		
		if(!isset($_SESSION['EA_END']) || !isset($_SESSION['EA_ACCESS']) || !isset($_SESSION['EA_IP']) || !isset($_SESSION['EA_START']) || !isset($_SESSION['EA_TYPE']) || !isset($_SESSION['EA_USER_AGENT'])) {
			$allow = 0;
		}
		
		if($_SESSION['EA_END'] < time() || $_SESSION['EA_IP'] != $this->clientIP || $_SESSION['EA_USER_AGENT'] != $_SERVER['HTTP_USER_AGENT']) {
			$allow = 0;
		} else if($_SESSION['EA_END'] > time()) {
			//Рвем сессию через 5 часов
			if(($_SESSION['EA_START']+18000) < time()) {
				$this->goToLogin();
			} else {
				$_SESSION['EA_END'] = time()+1800;
			}
		}
		
		return $allow;
	}
	
	function strrand($num = 15) {
		$permitted_chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		return substr(str_shuffle($permitted_chars), 0, $num);
	}
	
	function goToLogin($ref = '') {
		$this->db->Disconnect();

		$this->logOut();
		header("HTTP/1.1 301 Moved Permanently");
		header('Location: '.$this->loginURL.((!empty($ref)) ? '?ref='.base64_encode($ref) : ''));
		die();
	}
	
	function loginSuccess($ref = '/') {
		$this->db->Disconnect();
		
		if($ref == '/' && isset($_GET['ref']) && !empty($_GET['ref'])) {
			$ref = base64_decode($_GET['ref']);
		}
		header("HTTP/1.1 301 Moved Permanently");
		header('Location: '.$ref);
		die;
	}
	
	function blockPage($ref = '') {
		$this->db->Disconnect();
		header("HTTP/1.1 301 Moved Permanently");
		header('Location: '.$this->blockURL.((!empty($ref)) ? '?ref='.urlencode($ref) : ''));
		die();
	}
	
	function unauthorized() {
		$this->db->Disconnect();
		
		header('WWW-Authenticate: EAuth realm="'.$this->strrand(10).'"');
		header('HTTP/1.0 401 Unauthorized');
		die();
	}
	
	function saveParams($data=1) {
		$p=array();
		if (IsSet($this->id)) {
		$p["id"]=$this->id;
		}
		if (IsSet($this->view_mode)) {
		$p["view_mode"]=$this->view_mode;
		}
		if (IsSet($this->edit_mode)) {
		$p["edit_mode"]=$this->edit_mode;
		}
		if (IsSet($this->tab)) {
		$p["tab"]=$this->tab;
		}
		if (IsSet($this->ajax)) {
		$p["ajax"]=$this->ajax;
		}
		return parent::saveParams($p);
	}
	function getParams() {
		global $id;
		global $mode;
		global $view_mode;
		global $edit_mode;
		global $tab;
		global $ajax;
		
		if (isset($id)) {
		$this->id=$id;
		}
		if (isset($mode)) {
		$this->mode=$mode;
		}
		if (isset($view_mode)) {
		$this->view_mode=$view_mode;
		}
		if (isset($edit_mode)) {
		$this->edit_mode=$edit_mode;
		}
		if (isset($tab)) {
		$this->tab=$tab;
		}
		if (isset($ajax)) {
		$this->ajax=$ajax;
		}
	}

	function run() {
		global $session;
		$out=array();
		if ($this->action=='admin') {
		$this->admin($out);
		} else {
		$this->usual($out);
		}
		if (IsSet($this->owner->action)) {
		$out['PARENT_ACTION']=$this->owner->action;
		}
		if (IsSet($this->owner->name)) {
		$out['PARENT_NAME']=$this->owner->name;
		}
		if(isset($this->view_mode)) $out['VIEW_MODE'] = $this->view_mode;
		if(isset($this->edit_mode)) $out['EDIT_MODE'] = $this->edit_mode;
		if(isset($this->mode)) $out['MODE']=$this->mode;
		if(isset($this->action)) $out['ACTION']=$this->action;
		if(isset($this->ajax)) $out['AJAX']=$this->ajax;
		
		$this->data=$out;
		$p=new parser(DIR_TEMPLATES.$this->name."/".$this->name.".html", $this->data, $this);
		$this->result=$p->result;
	}

	function admin(&$out) {
		$this->getConfig();
		
		if(isset($this->view_mode)) {
			if($this->view_mode == 'addtokenform') {
				//Отправка формы на сервер
				$this->addTokenAccess();
			} else if($this->view_mode == 'addPodsetByIPForm') {
				//Отправка формы на сервер
				$this->addAccessByIP();
			} else if($this->view_mode == 'addloginpassform') {
				//Отправка формы на сервер
				$this->addAccessByLogPass();
			} else if($this->view_mode == 'addpathform') {
				//Отправка формы на сервер
				$this->addAccessByPath();
			} else if($this->view_mode == 'deltoken') {
				//Удаление токена
				$this->deltoken();
			} else if($this->view_mode == 'delip') {
				//Удаление токена
				$this->delip();
			} else if($this->view_mode == 'delloginpass') {
				//Удаление токена
				$this->delloginpass();
			} else if($this->view_mode == 'editsettings') {
				//Удаление токена
				$this->editsettings();
			} else if($this->view_mode == 'add') {
				//Страница создания токена
				$out['MODULE_LIST'] = $this->moduleList();
			}
		}
		
		$tokenList = $this->tokenList();
		$out['TOKEN_LIST'] = (count($tokenList) != 0) ? $tokenList : '';
		$loginList = $this->loginList();
		$out['LOGIN_LIST'] = (count($loginList) != 0) ? $loginList : '';
		$IPList = $this->IPList();
		$out['IP_LIST'] = (count($IPList) != 0) ? $IPList : '';
		$pathList = $this->pathList();
		$out['PATH_LIST'] = (count($pathList) != 0) ? $pathList : '';
		$out['LOGS_DATE'] = date('Y-m-d', time());
		$out['MYIP'] = $this->clientIP;
		$out['VERSION'] = $this->version;
		
		
		$out['SETTINGS_BANAFTER'] = $this->config['SETTINGS_BANAFTER'];
		$out['SETTINGS_BASICREQ'] = $this->config['SETTINGS_BASICREQ'];
		$out['SETTINGS_DDOSBAN'] = $this->config['SETTINGS_DDOSBAN'];
		$out['SETTINGS_BANTIME'] = $this->config['SETTINGS_BANTIME'];
		$out['SETTINGS_SEARCHHIDE'] = $this->config['SETTINGS_SEARCHHIDE'];
	}
	
	function editsettings() {
		global $banAfter;
		global $basicReq;
		global $ddosBan;
		global $banTime;
		global $searchHide;
		
		$this->config['SETTINGS_BANAFTER'] = $banAfter;
		$this->config['SETTINGS_BASICREQ'] = $basicReq;
		$this->config['SETTINGS_DDOSBAN'] = $ddosBan;
		$this->config['SETTINGS_BANTIME'] = $banTime;
		$this->config['SETTINGS_SEARCHHIDE'] = $searchHide;
		
		$this->saveConfig();
		$this->redirect("?");
	}
	
	function deltoken() {
		SQLExec("DELETE FROM `ea_tokens` WHERE `ID` = '".$this->id."' LIMIT 1");
		$this->redirect("?");
	}
	
	function delip() {
		SQLExec("DELETE FROM `ea_ip` WHERE `ID` = '".$this->id."' LIMIT 1");
		$this->redirect("?");
	}
	
	function delloginpass() {
		SQLExec("DELETE FROM `ea_login` WHERE `ID` = '".$this->id."' LIMIT 1");
		$this->redirect("?");
	}
	
	function addAccessByPath() {
		global $authCount;
		global $expireDate;
		global $pathAccess;
		
		$authCount = ($authCount) ? $authCount : 9999;
		$expireDate = ($expireDate) ? strtotime($expireDate)+86399 : strtotime("today", time())+86399;
		
		if(is_array($pathAccess)) {
			foreach($pathAccess as $value) {
				if(empty($value)) continue;
				$rec = SQLSelectOne("SELECT * FROM `ea_path` WHERE `PATH` = '".dbSafe($value)."'");
				$rec['EXPIRE'] = $expireDate;
				$rec['EXPIRE_COUNT'] = $authCount;
				$rec['PATH'] = $value;
				$rec['ADD'] = time();
				
				SQLInsertUpdate('ea_path', $rec);
			}
		} else {
			$out['CREATE_ERROR'] = 'Не указан путь!';
		}
		
		$this->redirect("?");
	}
	
	function addAccessByIP() {
		global $allowIP;
		global $expireDate;
		global $authCount;
		global $IPDie;
		
		$authCount = ($authCount) ? $authCount : 9999;
		$expireDate = ($expireDate) ? strtotime($expireDate)+86399 : strtotime("today", time())+86399;
		
		if($IPDie == 'on') $authCount = '-2';
		
		if(is_array($allowIP)) {
			foreach($allowIP as $value) {
				if(empty($value)) continue;
				$rec = SQLSelectOne("SELECT * FROM `ea_ip` WHERE IP = '".dbSafe($value)."'");
				$rec['EXPIRE'] = $expireDate;
				$rec['EXPIRE_COUNT'] = $authCount;
				$rec['IP'] = $value;
				$rec['ADD'] = time();
				
				SQLInsertUpdate('ea_ip', $rec);
			}
		} else {
			$out['CREATE_ERROR'] = 'Не указаны IP адреса!';
		}
		
		$this->redirect("?");
	}
	
	function addTokenAccess() {
		global $authCount;
		global $moduleAccess;
		global $expireDate;
		
		$authCount = ($authCount) ? $authCount : 9999;
		$moduleAccess = (is_array($moduleAccess)) ? implode(',', $moduleAccess) : 'all';
		$expireDate = ($expireDate) ? strtotime($expireDate)+86399 : strtotime("today", time())+86399;
		
		$rec['TOKEN'] = md5(rand(1000, 999999).time());
		$rec['EXPIRE'] = $expireDate;
		$rec['EXPIRE_COUNT'] = $authCount;
		$rec['ACCESS'] = $moduleAccess;
		$rec['ADD'] = time();
		
		SQLInsert('ea_tokens', $rec);
		
		$this->redirect("?");
	}
	
	function addAccessByLogPass() {
		global $authCount;
		global $moduleAccess;
		global $expireDate;
		global $login;
		global $pass;
	
		$authCount = ($authCount) ? $authCount : 9999;
		$moduleAccess = (is_array($moduleAccess)) ? implode(',', $moduleAccess) : 'all';
		$expireDate = ($expireDate) ? strtotime($expireDate)+86399 : strtotime("today", time())+86399;
		
		$login = trim(htmlspecialchars(strip_tags($login)));
		$login = preg_replace("/[^a-zA-Z0-9]/", '', $login);
		$pass = trim(htmlspecialchars(strip_tags($pass)));
		
		$ifDouble = SQLSelectOne("SELECT ID FROM `ea_login` WHERE `LOGIN` = '".dbSafe($login)."'");
		
		if(strlen($login) < 5 || strlen($pass) < 5 || count($ifDouble) != 0) {
			return false;
		}
		
		$rec['LOGIN'] = $login;
		$rec['PASSWORD'] = password_hash($pass, PASSWORD_DEFAULT);
		$rec['EXPIRE'] = $expireDate;
		$rec['EXPIRE_COUNT'] = $authCount;
		$rec['ACCESS'] = $moduleAccess;
		$rec['ADD'] = time();
		
		SQLInsert('ea_login', $rec);
		
		$this->redirect("?");
	}
	
	function moduleList() {
		$list = SQLSelect("SELECT NAME, TITLE FROM `project_modules`");
		
		return $list;
	}
	
	function tokenList() {
		$list = SQLSelect("SELECT * FROM `ea_tokens`");
		$arrayPluginsName = SQLSelect("SELECT NAME, TITLE FROM `project_modules`");
		$arrayPluginsNameHuman = [
			'all' => 'Полный доступ',
			'show_web' => 'Просмотр и управление сценами',
			'allow_gps' => 'Доступ к GPS.php',
			'allow_console' => 'Доступ к консоли',
		];
		
		foreach($arrayPluginsName as $keyPlg => $pluginsValue) {
			$arrayPluginsNameHuman[$pluginsValue["NAME"]] = $pluginsValue["TITLE"];
		}

		foreach($list as $key => $value) {
			$list[$key]['ADD_HUMAN'] = date('d.m.Y H:i:s', $value['ADD']);
			$list[$key]['EXPIRE_HUMAN'] = date('d.m.Y H:i:s', $value['EXPIRE']);
		
			$expAccess = explode(',', $value['ACCESS']);
			
			foreach($expAccess as $valueAccess) {
				$list[$key]['ACCESS_HUMAN'] .= $arrayPluginsNameHuman[$valueAccess].'<br>';
			}
		}
		return $list;
	}
	
	function loginList() {
		$list = SQLSelect("SELECT * FROM `ea_login`");
		$arrayPluginsName = SQLSelect("SELECT NAME, TITLE FROM `project_modules`");
		$arrayPluginsNameHuman = [
			'all' => 'Полный доступ',
			'show_web' => 'Просмотр и управление сценами',
			'allow_gps' => 'Доступ к GPS.php',
			'allow_console' => 'Доступ к консоли',
		];
		
		foreach($arrayPluginsName as $keyPlg => $pluginsValue) {
			$arrayPluginsNameHuman[$pluginsValue["NAME"]] = $pluginsValue["TITLE"];
		}

		foreach($list as $key => $value) {
			$list[$key]['ADD_HUMAN'] = date('d.m.Y H:i:s', $list[$key]['ADD']);
			$list[$key]['EXPIRE_HUMAN'] = date('d.m.Y H:i:s', $list[$key]['EXPIRE']);
			//$list[$key]['ACCESS_HUMAN'] = str_replace(",", "<br>", $list[$key]['ACCESS']);
			
			$expAccess = explode(',', $value['ACCESS']);
			foreach($expAccess as $valueAccess) {
				$list[$key]['ACCESS_HUMAN'] .= $arrayPluginsNameHuman[$valueAccess].'<br>';
			}
		}
		return $list;
	}
	
	function IPList() {
		$list = SQLSelect("SELECT * FROM `ea_ip`");
		
		foreach($list as $key => $value) {
			$list[$key]['ADD_HUMAN'] = date('d.m.Y H:i:s', $list[$key]['ADD']);
			$list[$key]['EXPIRE_HUMAN'] = date('d.m.Y H:i:s', $list[$key]['EXPIRE']);
		}
		return $list;
	}
	
	function pathList() {
		$list = SQLSelect("SELECT * FROM `ea_path`");
		
		foreach($list as $key => $value) {
			$list[$key]['ADD_HUMAN'] = date('d.m.Y H:i:s', $list[$key]['ADD']);
			$list[$key]['EXPIRE_HUMAN'] = date('d.m.Y H:i:s', $list[$key]['EXPIRE']);
		}
		return $list;
	}
	
	function checkIP() {
		$client = $this->clientIP;
		$allow = 0;

		$allowList = SQLSelect("SELECT * FROM `ea_ip` LIMIT 50");
		if(!is_array($allowList)) return $allow;
		
		foreach($allowList as $key => $value) {
			if($value['IP'] == $client && $value['EXPIRE_COUNT'] == '-2') {
				return 0;
				break;
			}
			
			$p = preg_quote($value['IP']);
			$p = str_replace('\*', '\d+?', $p);
			$p = str_replace(',', ' ', $p);
			$p = str_replace('  ', ' ', $p);
			$p = str_replace(' ', '|', $p);
			
			$allow = preg_match('/' . $p . '/is', $client);
			
			$ipinfo = $this->getIPInfo();
			
			//Прошел проверку на ИП
			if($allow == 1) {
				//Проверим срок действия
				if($value['EXPIRE'] > time()) {
					//Есть попытки входа или нет
					if($value['EXPIRE_COUNT'] >= '1') {
						if(empty($_SESSION['EA_TYPE'])) {
							$allowList[$key]['EXPIRE_COUNT'] = $value['EXPIRE_COUNT']-1;
							SQLUpdate("ea_ip", $allowList[$key]);
						}
						
						$this->log('<b style="color: green;">'.$ipinfo.'</b> -> успешный вход по IP!');
						
						return $this->sessionStart('IP', 'all');
					} else if($value['EXPIRE_COUNT'] == '-1') {
						$this->log('<b style="color: green;">'.$ipinfo.'</b> -> успешный вход по IP!');
						
						return $this->sessionStart('IP', 'all');						
					} else if($value['EXPIRE_COUNT'] == '0') {
						$allow = 0;
						$this->log('<b style="color: orange;">'.$ipinfo.'</b> -> закончились разрешения на вход (Количество)!');
						
						SQLExec("DELETE FROM `ea_ip` WHERE `IP` = '".$value['IP']."' LIMIT 1");
						
						$this->logOut();
					}
				} else {
					$allow = 0; 
					$this->log('<b style="color: orange;">'.$ipinfo.'</b> -> закончились разрешения на вход (Время)!');
					SQLExec("DELETE FROM `ea_ip` WHERE `IP` = '".$value['IP']."' LIMIT 1");
					$this->logOut();
				}
				
				break;
			}
		}
		
		return $allow;
	}
	
	function checkToken($token) {
		$token = htmlspecialchars(strip_tags($token));
		$token = preg_replace("/[^a-zA-ZА-Яа-я0-9]/", '', $token);
		$token = substr($token, 0, 32);
		
		$responce = [
			'status' => false,
			'msg' => 'Неизвестная ошибка!',
			'token' => $token
		];
		
		$ipinfo = $this->getIPInfo();
		
		if(strlen($token) == 32) {
			$req = SQLSelectOne("SELECT * FROM `ea_tokens` WHERE TOKEN = '".dbSafe($token)."'");
			
			if(!$req['ID']) {
				$responce['msg'] = 'Токен не существует!';
				$this->log('<b style="color: red;">'.$ipinfo.'</b> -> ошибка авторизации с токеном: '.$responce['token'].' - '.$responce['msg']);
				return $responce;
			} else if($req['EXPIRE'] < time()) {
				$responce['msg'] = 'Токен просрочен!';
				$this->log('<b style="color: red;">'.$ipinfo.'</b> -> ошибка авторизации с токеном: '.$responce['token'].' - '.$responce['msg']);
				return $responce;
			} else if($req['EXPIRE_COUNT'] == 0) {
				$responce['msg'] = 'Использован весь лимит доступа по токену!';
				$this->log('<b style="color: red;">'.$ipinfo.'</b> -> ошибка авторизации с токеном: '.$responce['token'].' - '.$responce['msg']);
				return $responce;
			}
			 
			//Если ошибок нет, снимаем 1 доступ
			if($req['EXPIRE_COUNT'] != '-1') {
				$req['EXPIRE_COUNT'] = $req['EXPIRE_COUNT']-1;
				SQLUpdate('ea_tokens', $req);
			}
			$responce['status'] = true;
			$responce['msg'] = 'Успешный вход!';
			
			$ipinfo = $this->getIPInfo();
			$this->log('<b style="color: green;">'.$ipinfo.'</b> -> успешный вход с токеном: '.$responce['token']);
		
			$this->sessionStart('TOKEN', $req['ACCESS']);
			
			return $responce;
		} else {
			$responce['msg'] = 'Неверная длина токена!'; 
			$this->log('<b style="color: red;">'.$ipinfo.'</b> -> ошибка авторизации с токеном: '.$responce['token'].' - '.$responce['msg']);
			return $responce;
		}
	}
	
	function checkLoginPass($basicLogin = '', $basicPass = '') {
		global $ea_login;
		global $ea_pass;
	
		$ea_login = (!empty($basicLogin)) ? $basicLogin : $ea_login;
		$ea_pass = (!empty($basicPass)) ? $basicPass : $ea_pass;
		
		if(!empty($basicLogin)) {
			$authType = 'Basic';
		} else {
			$authType = 'Login Page';
		}
		
		$login = trim(htmlspecialchars(strip_tags($ea_login)));
		$login = preg_replace("/[^a-zA-Z0-9]/", '', $login);
		$pass = trim(htmlspecialchars(strip_tags($ea_pass)));
		
		$req = SQLSelectOne("SELECT * FROM `ea_login` WHERE `LOGIN` = '".dbSafe($login)."'");
		
		if(strlen($login) < 5 || strlen($pass) < 5 || count($req) == 0) {
			$ipinfo = $this->getIPInfo();
			$this->log('<b style="color: red;">'.$ipinfo.'</b> -> короткий логин/пароль/неверный логин. Логин: '.$login.' ('.$authType.')');
			return false;
		}
		
		$passVerify = password_verify($pass, $req['PASSWORD']);
		
		if($passVerify) {
			if($req['EXPIRE'] < time()) {
				$ipinfo = $this->getIPInfo();
				$this->log('<b style="color: red;">'.$ipinfo.'</b> -> истекло время доступа. Логин: '.$login.' ('.$authType.')');
				return false;
			} else if($req['EXPIRE_COUNT'] == 0) {
				$ipinfo = $this->getIPInfo();
				$this->log('<b style="color: red;">'.$ipinfo.'</b> -> использован весь лимит доступа. Логин: '.$login.' ('.$authType.')');
				return false;
			}
			
			//Если ошибок нет, снимаем 1 доступ
			if($req['EXPIRE_COUNT'] >= '1') {
				$req['EXPIRE_COUNT'] = $req['EXPIRE_COUNT']-1;
				SQLUpdate('ea_login', $req);
			}
			
			$ipinfo = $this->getIPInfo();
			$this->log('<b style="color: green;">'.$ipinfo.'</b> -> успешный вход с логином: '.$login.' ('.$authType.')');
		
			$this->sessionStart('LOGIN', $req['ACCESS']);

			if(!empty($basicLogin)) {
				return true;
			} else {
				$this->loginSuccess();
			}
		} else {
			$ipinfo = $this->getIPInfo();
			$this->log('<b style="color: red;">'.$ipinfo.'</b> -> неверный пароль. Логин: '.$login.' ('.$authType.')');
			return false;
		}
	}
	
	function sessionStart($type, $access) {
		$_SESSION['EA_TYPE'] = $type;
		$_SESSION['EA_START'] = time();
		$_SESSION['EA_END'] = time()+1800;
		$_SESSION['EA_LOGIN'] = '';
		$_SESSION['EA_ACCESS'] = $access;
		$_SESSION['EA_IP'] = $this->clientIP;
		$_SESSION['EA_USER_AGENT'] = $_SERVER['HTTP_USER_AGENT'];
		$_SESSION['EA_ERROR_COUNT'] = 0;
		
		//Удалим из бан листа

		return true;
	}
	
	function logOut() {
		unset($_SESSION['EA_TYPE']);
		unset($_SESSION['EA_START']);
		unset($_SESSION['EA_END']);
		unset($_SESSION['EA_LOGIN']);
		unset($_SESSION['EA_ACCESS']);
		unset($_SESSION['EA_IP']);
		unset($_SESSION['EA_USER_AGENT']);
		unset($_SESSION['EA_ERROR_COUNT']);
		
		unset($_SESSION);
		session_destroy();
	}
	
	function log($str) {
		debmes($str, 'ea_log');
	}
	
	function checkAccessByPath() {
		$allow = 0;

		$url = $this->curPage;

		if(empty($url)) return $allow;
		
		//Посмотрим к чему разрешен доступ в БД
		$allowList = SQLSelect("SELECT * FROM `ea_path` LIMIT 50");
		if(!is_array($allowList)) return $allow;
		
		foreach($allowList as $key => $value) {
			if($url == $value['PATH']) {
				//Проверим срок действия
				if($value['EXPIRE'] > time()) {
					//Есть попытки входа или нет
					if($value['EXPIRE_COUNT'] >= '1') {
						$allowList[$key]['EXPIRE_COUNT'] = $value['EXPIRE_COUNT']-1;
						SQLUpdate("ea_path", $allowList[$key]);
						$allow = 1;
					} else if($value['EXPIRE_COUNT'] == '-1') {
						$allow = 1;
					} else if($value['EXPIRE_COUNT'] == '0') {
						$allow = 0;
						$this->log('Страница <b color="red">'.($value['PATH']).'</b> -> закончились разрешения на вход (Количество)!');
						$this->logOut();
					}
				} else {
					$allow = 0;
					$this->log('Страница <b color="red">'.($value['PATH']).'</b> -> закончились разрешения на вход (Время)!');
					$this->logOut();
				}
				break;
			}
		}
		
		return $allow;
	}
	
	function checkAccessPermission() {
		$allow = 0;
		
		//Работаем только с токеном, ИП и логины пропускам, так же пропустим, если есть полный доступ.
		//Так же эта функция отработает при входе через логин ибо у них одинаковая структура
		if(explode(',', $_SESSION['EA_ACCESS'])[0] == 'all') {
			$allow = 1;
			return $allow;
		}
		
		if(!$_GET['action'] && !$_GET['md']) {
			if($this->curPage == '/index.php' || strripos($_SERVER["REQUEST_URI"], '/page/') !== false || strripos($_SERVER["REQUEST_URI"], '/module/') !== false || strripos($_SERVER["REQUEST_URI"], '/popup/') !== false || strripos($_SERVER["REQUEST_URI"], '/devices') !== false || strripos($_SERVER["REQUEST_URI"], '/menu') !== false || strripos($_SERVER["REQUEST_URI"], '/apps') !== false || strripos($_SERVER["REQUEST_URI"], '/pages') !== false) {
				$_GET['action'] = 'show_web';
			} else {
				$_GET['action'] = 'dashboard';
			}
		} else if(!$_GET['action'] && $_GET['md']) {
			if($_GET['md'] == 'panel') {
				$_GET['action'] = 'dashboard';
			} else {
				$_GET['action'] = $_GET['md'];
			}	
		} else if(strripos($_SERVER["REQUEST_URI"], '/gps.php') !== false) {
			$_GET['action'] = 'allow_gps';
		}
		
		if($_POST['op'] == 'console' && strripos($_SESSION['EA_ACCESS'], 'allow_console') === false) {
			return 0;
		}
		
		if (strripos($_SESSION['EA_ACCESS'], $_GET['action']) !== false) {
			$allow = 1;
		}
		
		
		return $allow;
	}
	
	function checkAccessByIP() {
		$client = $this->clientIP;
		$allow = 0;

		$allowList = SQLSelect("SELECT * FROM `ea_ip` LIMIT 50");
		if(!is_array($allowList)) return $allow;

		foreach($allowList as $key => $value) {
			//Пермаментный блок
			if($value['IP'] == $client && $value['EXPIRE_COUNT'] == '-2') {
				return 0;
				break;
			}
			
			$p = preg_quote($value['IP']);
			$p = str_replace('\*', '\d+?', $p);
			$p = str_replace(',', ' ', $p);
			$p = str_replace('  ', ' ', $p);
			$p = str_replace(' ', '|', $p);
			
			$allow = preg_match('/' . $p . '/is', $client);
			
			//Прошел проверку на ИП
			if($allow == 1) {
				//Проверим срок действия
				if($value['EXPIRE'] > time()) {
					//Есть попытки входа или нет
					if($value['EXPIRE_COUNT'] >= '1') {
						$allowList[$key]['EXPIRE_COUNT'] = $value['EXPIRE_COUNT']-1;
						SQLUpdate("ea_ip", $allowList[$key]);
						return $this->sessionStart('IP', 'all');
					} else if($value['EXPIRE_COUNT'] == '0') {
						$allow = 0;
						$this->log('<b style="color: orange;">Для IP '.($this->getIPInfo()).'</b> -> закончились разрешения на вход (Количество)!');
						$this->logOut();
					}
				} else {
					$allow = 0;
					$this->log('<b style="color: orange;">Для IP '.($this->getIPInfo()).'</b> -> закончились разрешения на вход (Время)!');
					$this->logOut();
				}
				
				break;
			}
		}
		
		return $allow;
	}
	
	function getIPInfo($full = 0) {
		
		$get = file_get_contents('https://ipwhois.app/json/'.$this->clientIP.'&lang=ru');
		$get = json_decode($get, TRUE);
		
		if($get["success"] == true) {
			$ipInfo = '<img style="width: 20px;vertical-align: sub;margin-right: 7px;" src="'.$get["country_flag"].'">'.$this->clientIP.' '.$get["region"].' ('.$get["city"].', '.$get["org"].')';
		} else {
			$ipInfo = $this->clientIP;
		}
		
		if($full == 1) {
			return $get;
		} else {
			return $ipInfo;
		}
	}
	
	function usual(&$out) {
	
		
	}

	function install($data='') {
		parent::install();
	}
	
	function uninstall() {
		SQLDropTable('ea_tokens');
		SQLDropTable('ea_ip');
        parent::uninstall();
    }

    function dbInstall($data) {
        $data = <<<EOD
ea_tokens: ID int(10) unsigned NOT NULL auto_increment
ea_tokens: TOKEN varchar(255) NOT NULL DEFAULT ''
ea_tokens: EXPIRE varchar(255) NOT NULL DEFAULT ''
ea_tokens: EXPIRE_COUNT int(10) NOT NULL DEFAULT 0
ea_tokens: ACCESS text(1500) NOT NULL DEFAULT ''
ea_tokens: ADD varchar(255) NOT NULL DEFAULT '' 

ea_login: ID int(10) unsigned NOT NULL auto_increment
ea_login: LOGIN varchar(255) NOT NULL DEFAULT ''
ea_login: PASSWORD varchar(255) NOT NULL DEFAULT ''
ea_login: EXPIRE varchar(255) NOT NULL DEFAULT ''
ea_login: EXPIRE_COUNT int(10) NOT NULL DEFAULT 0
ea_login: ACCESS text(1500) NOT NULL DEFAULT ''
ea_login: ADD varchar(255) NOT NULL DEFAULT '' 

ea_ip: ID int(10) unsigned NOT NULL auto_increment
ea_ip: IP varchar(255) NOT NULL DEFAULT ''
ea_ip: EXPIRE varchar(255) NOT NULL DEFAULT ''
ea_ip: EXPIRE_COUNT int(10) NOT NULL DEFAULT 0
ea_ip: ACCESS text(1500) NOT NULL DEFAULT ''
ea_ip: ADD varchar(255) NOT NULL DEFAULT '' 

ea_path: ID int(10) unsigned NOT NULL auto_increment
ea_path: PATH varchar(255) NOT NULL DEFAULT ''
ea_path: EXPIRE varchar(255) NOT NULL DEFAULT ''
ea_path: EXPIRE_COUNT int(10) NOT NULL DEFAULT 0
ea_path: ADD varchar(255) NOT NULL DEFAULT '' 

ea_ban: ID int(10) unsigned NOT NULL auto_increment
ea_ban: IP varchar(255) NOT NULL DEFAULT ''
ea_ban: STATUS int(10) NOT NULL DEFAULT 0
ea_ban: EXPIRE varchar(255) NOT NULL DEFAULT ''
ea_ban: ATTEMPT_FAIL int(10) NOT NULL DEFAULT 0
ea_ban: ATTEMPT_OPEN int(10) NOT NULL DEFAULT 0
ea_ban: UPDATE varchar(255) NOT NULL DEFAULT '' 
ea_ban: ADD varchar(255) NOT NULL DEFAULT '' 
 
EOD;
        parent::dbInstall($data);
    }
}
